// regex_replace example
#include <iostream>
#include <string>
#include <regex>
#include <iterator>

int main(int argc, char const *argv[])
{
    std::string s (argv[1]);
    std::smatch m;

    //check the entire name has the paraview format
    std::regex r ("(.*0\\.[0-9]*\\.csv)");
    if(!std::regex_match(s,m,r)){
      std::cout<<"File "<<s<<" does not fit the regular expression. Skipping it\n";
      return -1;
    }

    //the bit that needs to be replaced
    std::regex e ("(0\\.[0-9])");
    std::regex_search (s,m,e);
    std::string mat = m[0];
    

    //replace it
    //-------------------
    std::string reg = std::string()+"(0\\.)("+mat.back()+")";
    std::regex e2(reg.c_str());
    
    //evil concatenation hack
    std::string n = std::string() + "_" + mat.back();
    
    std::string new_name = std::regex_replace(s, e2, n);

    rename(argv[1], new_name.c_str());
  return 0;
}